;compiler: avrasm

;ukazkovy program pro praci se souborovym systemem FAT16, vypis nekterych informaci na terminal a vypis stromu adresaru
;posledni uprava: 21.12.2005
;dotazy na s.maslan@seznam.cz
;MCU - ATmega32
;naprogramovat fusebit CKOPT !!!!!! jinak bude USART rusit krystal

;melo by to fungovat, ale pokud nekdo nalezne chybu, necht poda hlaseni :-) - mozna opravim

	.include "m32def.inc"
	.dseg
FAT1LBAadress:	.byte	4	;LBA - zacatek 1.FAT
RootLBAadress:	.byte	4	;LBA - zacatek root adresare
DataLBAadress:	.byte	4	;LBA - zacatek dat
SecPerCluster:	.byte	1	;pocet sektoru na cluster
RootDirSectors:	.byte	1	;pocet sektoru root adresare
SubFolderLev:	.byte	1	;aktualni uroven podadresare (odpovida poctu zanoreni rekurzivni fce)
TotalEntries:	.byte	2	;celkovy pocet vypsanych polozek
TreeTime:	.byte	4	;zmereny cas vypisu stromu
TreeFilesSize:	.byte	4	;Bytu v souborech
EntryNameString:	.byte	92	;nacteny nazev souboru v kodovani CP1250
EntryNameLen:	.byte	1	;delka nazvu
	.equ	BufferSize=512+256	;velikost DataBufferu (512B sector buffer + 256B pro nacitani LFN)
DataBuffer:	.byte	BufferSize	;tohle je ten buffer
	
	.cseg
	.org	$000	;inicializace
	rjmp	Init
	.org	$014
	;preruseni casovace 1000x/sec
	push	R16
	push	R17
	push	R18
	push	R19
	in	R16,sreg
	push	R16
	;pricist 1ms
	lds	R16,TreeTime+0
	lds	R17,TreeTime+1
	lds	R18,TreeTime+2
	lds	R19,TreeTime+3
	subi	R16,low(-1)
	sbci	R17,high(-1)
	sbci	R18,byte3(-1)
	sbci	R19,byte4(-1)
	sts	TreeTime+0,R16
	sts	TreeTime+1,R17
	sts	TreeTime+2,R18
	sts	TreeTime+3,R19
	;
	pop	R16
	out	sreg,R16
	pop	R19
	pop	R18
	pop	R17
	pop	R16
	reti
	
;***********************************************************************************************************************
;	Inicializace
;***********************************************************************************************************************
Init:	;pocatecni nastaveni portu a pinu
	ldi	R16,0b11111111
	out	ddra,R16	;adresa/high data
	ldi	R16,0b11111011
	out	ddrd,R16
	ldi	R16,0b11111111
	out	ddrb,R16
	ldi	R16,0b11111111
	out	ddrc,R16	;low data
	;
	sbi	portd,7	;IOWR
	sbi	portd,3	;IORD
	sbi	portb,3	;RAM WR
	sbi	portd,4	;RAM OE
	sbi	portd,6	;A16-A19 buffer CK
	sbi	portd,5	;A8-A15 buffer CK
	cbi	portb,0	;LCD E
	cbi	portb,1	;LCD RS
	;timer 0 - pro mereni casu
	ldi	R16,0b00001011	;timer 0 - delitel XTAL/64
	out	tccr0,R16
	ldi	R16,249	;1000Hz
	out	ocr0,R16
	ldi	R16,0b00000010
	out	timsk,R16
	;stack ptr na konec RAM
	ldi	R16,high(ramend)
	out	sph,R16	;nastav SP na konec SRAM
	ldi	R16,low(ramend)
	out	spl,R16	;nastav SP na konec SRAM
	;USART jen pro TX, 8bit, bez parity
	ldi	R16,0b00000010
	out	ucsra,R16
	ldi	R16,0b00001000
	out	ucsrb,R16
	ldi	R16,0b10000110
	out	ucsrc,R16
	ldi	R16,0b00000000
	out	ubrrh,R16	;high baudrate
	;hodnoty plati pro XTAL=16MHz
;	ldi	R16,103	;19200bd
;	ldi	R16,34	;57600bd
	ldi	R16,16	;115200bd
;	ldi	R16,8	;230400bd
;	ldi	R16,3	;500000bd
;	ldi	R16,1	;1000000bd
;	ldi	R16,0	;2000000bd
	;
	out	ubrrl,R16	;low baudrate
	;chvili cekat
	ldi	R16,20
	call	DelayLongVar
	;inicilaizace LCD
	call	LCDinit
	;vypis inicializace na terminal a LCD
	ldi	R30,low(TextHDDinitT*2)
	ldi	R31,high(TextHDDinitT*2)
	rcall	PrintHDLN	;terminal
	call	LCDclrAll
	ldi	R30,low(TextHDDinitT*2)
	ldi	R31,high(TextHDDinitT*2)
	call	LCDwrStrFLASH	;a na LCD
	;chvili cekat
	ldi	R16,20
	call	DelayLongVar
	;inicializace HDD/CF
	rcall	WaitInitIDE
	;vypis nacitam identifikacni blok
	ldi	R30,low(TextIDEidentRDT*2)
	ldi	R31,high(TextIDEidentRDT*2)
	rcall	PrintStrFLASH	;terminal
	rcall	TermBreakLine
	rcall	TermBreakLine
	call	LCDclrAll
	ldi	R30,low(TextIDEidentRDT*2)
	ldi	R31,high(TextIDEidentRDT*2)
	call	LCDwrStrFLASH	;a na LCD
	;
	rcall	IdentIDEdrive	;precist identifikacni blok
	rcall	SetDriveParam	;nastavit fyzickou geometrii HDD (nektere HDD to vyzaduji)
	rcall	PrintHDDident	;vypsat nektere udaje o IDE zarizeni
	;inicializace FAT
	rcall	ReadFATparam	;nacist nektere parametry FAT16 a zjistit, jestli tam vubec je, vypsat status
	rcall	PrintFATident	;vypsat nektere udaje o FAT16
	;vypis nacitam FAT16 do SRAM
	call	LCDclrAll
	ldi	R30,low(TextFATldT*2)
	ldi	R31,high(TextFATldT*2)
	call	LCDwrStrFLASH	;a na LCD
	;
	rcall	CopyFATextSRAM	;nacist FAT do externi SRAM na adresy 0x00000 az 0x1FFFF (128kB)
	;napis "vypis stromu"
	ldi	R30,low(TextTreePrintT*2)
	ldi	R31,high(TextTreePrintT*2)
	rcall	PrintHDLN	;na terminal
	call	LCDclrAll
	ldi	R30,low(TextTreeWRT*2)
	ldi	R31,high(TextTreeWRT*2)
	call	LCDwrStrFLASH	;a na LCD
	;
	ldi	R16,0	;vypsano 0 polozek
	sts	TotalEntries+0,R16
	sts	TotalEntries+1,R16
	ldi	R16,0	;nulta uroven podadresare - root
	sts	SubFolderLev,R16
	clr	R16
	sts	TreeTime+0,R16
	sts	TreeTime+1,R16
	sts	TreeTime+2,R16
	sts	TreeTime+3,R16	;nulovat cas
	sts	TreeFilesSize+0,R16
	sts	TreeFilesSize+1,R16
	sts	TreeFilesSize+2,R16
	sts	TreeFilesSize+3,R16	;nulovat celkovou velikost souboru
	;
	sei		;zacit merit cas
	rcall	LoadRootLBAad	;nacist LBA adresu root adresare
	rcall	LFNinitBuffer	;inicializace Bufferu pro LFN nazvy
	lds	R24,RootDirSectors	;projit vsechny sektory root
	rcall	FolderTree	;tady se prochazi root
	cli		;zastavit casovac
	;napis vypis dokoncen a vypis nekterych parametru
	rcall	TermBreakLine
	ldi	R30,low(TextTreeCPTDT*2)
	ldi	R31,high(TextTreeCPTDT*2)
	rcall	PrintHDLN	;na terminal
	call	LCDclrAll
	ldi	R30,low(TextTreeWRcompT*2)
	ldi	R31,high(TextTreeWRcompT*2)
	call	LCDwrStrFLASH	;a na LCD
	;vypsat pocet vypsanych polozek		
	ldi	R30,low(TextTEntrT*2)
	ldi	R31,high(TextTEntrT*2)
	rcall	PrintStrFLASH
	;
	lds	R16,TotalEntries+0
	lds	R17,TotalEntries+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine
	;vypsat celkovou velikost vsech souboru
	ldi	R30,low(TextTreeFsizT*2)
	ldi	R31,high(TextTreeFsizT*2)
	rcall	PrintStrFLASH
	;
	lds	R16,TreeFilesSize+0
	lds	R17,TreeFilesSize+1
	lds	R18,TreeFilesSize+2
	lds	R19,TreeFilesSize+3
	;
	clr	R0
	cp	R18,R0
	cpc	R19,R0
	brne	TreeFsizNIB
	;je to malo, takze v Bytech
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	ldi	R30,low(TextBT*2)
	ldi	R31,high(TextBT*2)
	rjmp	TreeFsizOk
TreeFsizNIB:	ldi	R20,low(1024)
	ldi	R21,high(1024)
	ldi	R22,byte3(1024)
	ldi	R23,byte4(1024)
	rcall	div32uc2
	clr	R0
	cp	R18,R0
	cpc	R19,R0
	brne	TreeFsizNIkB
	;je to uz vic, takze v kBytech
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	ldi	R30,low(TextkBT*2)
	ldi	R31,high(TextkBT*2)
	rjmp	TreeFsizOk
	;je toho moc, takze uz v MBytech
TreeFsizNIkB:	ldi	R20,low(1024)
	ldi	R21,high(1024)
	ldi	R22,byte3(1024)
	ldi	R23,byte4(1024)
	rcall	div32uc2
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	ldi	R30,low(TextMBT*2)
	ldi	R31,high(TextMBT*2)
	;
TreeFsizOk:	rcall	PrintStrFLASH
	rcall	TermBreakLine
	;ted napis jak dlouho trvalo vytvoreni stromu
	ldi	R30,low(TextTreeTimeT*2)
	ldi	R31,high(TextTreeTimeT*2)
	rcall	PrintStrFLASH
	;rozdelit na minuty, sekundy a milisekundy
	lds	R16,TreeTime+0
	lds	R17,TreeTime+1
	lds	R18,TreeTime+2
	lds	R19,TreeTime+3
	ldi	R20,low(1000*60)
	ldi	R21,high(1000*60)
	ldi	R22,byte3(1000*60)
	ldi	R23,byte4(1000*60)
	rcall	div32uc2
	movw	R20,R12
	rcall	bin2BCD16p5
	rcall	USRwrBCD16	;minuty
	ldi	R30,low(TextMinT*2)
	ldi	R31,high(TextMinT*2)
	rcall	PrintStrFLASH
	movw	R16,R20
	ldi	R18,low(1000)
	ldi	R19,high(1000)
	rcall	div16uc2
	movw	R20,R14
	rcall	bin2BCD16p5
	rcall	USRwrBCD16	;sekundy
	ldi	R30,low(TextSecT*2)
	ldi	R31,high(TextSecT*2)
	rcall	PrintStrFLASH
	movw	R16,R20
	rcall	bin2BCD16p5
	rcall	USRwrBCD16	;milisekundy
	ldi	R30,low(TextMSecT*2)
	ldi	R31,high(TextMSecT*2)
	rcall	PrintStrFLASH
	;zakousnout - hotovo
	rjmp	PC


;	nasledujici 2 kratke rutinky vypisuji strom, nezaradil jsem je do rotin pro FAT
;	ale samozrejme tam patri
	
;-----------------------------------------------------------------------------------------------------------------------
;rekurzivni funkce pro vypis obsahu podadresare zacinajiciho clusterem R16:R17
;kazde dalsi "vnoreni samo do sebe" vyzaduje 10B stacku + tvale musi byt rezerva si 20B (rcall,push)
;----------------------------------------------------------------------------------------------------------------------- 
SubFoldPrint:	push	R30
	push	R31	;zaloha pozice v sektor bufferu
	push	R7
	push	R8
	push	R9
	push	R10	;zaloha LBA adresy prave prochazeneho sektoru
	push	R24
	push	R25	;zaloha pozic vstupu v sektoru a cisla sektoru root
	push	R11
	push	R12	;zaloha cisla posledniho clusteru
	;uroven podadresare +1
	lds	R18,SubFolderLev
	inc	R18
	sts	SubFolderLev,R18
	;ted vypocet LBA adresy sektoru z cisla clusteru
SubFolderNextCl:	mov	R11,R16
	mov	R12,R17	;cislo aktualniho clusteru
	;
	rcall	LoadDataLBAad	;zacatek DAT
	subi	R16,low(2)
	sbci	R17,high(2)
	;vypocet pocatecniho sektoru z clusteru R16:R17
	lds	R18,SecPerCluster	
	mul	R16,R18
	movw	R2,R0
	mul	R17,R18
	clr	R4
	clr	R5
	add	R3,R0
	adc	R4,R1
	adc	R5,R5
	;
	add	R7,R2
	adc	R8,R3
	adc	R9,R4
	adc	R10,R5	;LBA adresa zacatku clusteru R16:R17
	;ted projit pocet sektoru nalezicich 1 clusteru
	lds	R24,SecPerCluster	;pocet sektoru clusteru
	rcall	FolderTree	;vypis polozek
	;ted zjistit dalsi cluster adresare
	clr	R13
	lsl	R11
	rol	R12
	rol	R13	;adresa clusteru ve FAT v SRAM
	rcall	LoadSRAMword	;nacist ho
	ldi	R18,high(0xFFF8)
	cpi	R16,low(0xFFF8)
	cpc	R17,R18	;kdyz je posledni, tak konec vypisu tohoto adresare
	brcs	SubFolderNextCl
	;posledni cluster oki, uroven podadresare -1
	lds	R16,SubFolderLev
	dec	R16
	sts	SubFolderLev,R16
	;obnova puvodnich registru, vystup z funkce
	pop	R12
	pop	R11	;obnova cisla posledniho clusteru
	pop	R25
	pop	R24	;obnova pozic vstupu v sektoru a cisla sektoru root
	pop	R10
	pop	R9
	pop	R8
	pop	R7	;obnova LBA adresy aktualniho sektoru
	rcall	RDsectorLBA	;obnova dat v zasobniku - znovu nacist sektor
	pop	R31
	pop	R30	;zaloha pozice v sektor bufferu
	ret
;-----------------------------------------------------------------------------------------------------------------------	
;	tahle rutina prochazi R24 sektoru od LBA adresy R7:R8:R9:R10 a vypisuje 
;	polozky podle nize zadanych podminek
;-----------------------------------------------------------------------------------------------------------------------
FolderTree:
NextSFSector:	rcall	RDsectorLBA	;nacist 1 sektor do bufferu
	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)	;Z na zacatek bufferu
	ldi	R25,16	;16 vstupu na sektor (1 vstup 32B, sektor 512B - 512/32=16)
	;testovat 1 vstup
NextSFEntry:	ld	R17,Z	;prvni znak nazvu - ofset 0x00
	adiw	R30,0xB	;na atribut vstupu
	cpi	R17,0xE5	;priznak smazaneho vstupu
	breq	LoadSFErEnt
	cpi	R17,0x00	;nic tu neni - nebyla zapsana polozka
	breq	LoadSFErEnt
	ld	R16,Z	;nacist atribut
	cpi	R16,0xF	;preskocit, kdyz LFN atribut
	breq	LoadSFErEnt
;	bst	R16,4	;jen adresare
;	brtc	LoadSFErEnt
	andi	R16,0b00001010	;preskocit, kdyz Disk label nebo skryty adresar
	brne	LoadSFErEnt
	cpi	R17,'.'
	breq	LoadSFErEnt	;nesmi to byt adresar "." ani "..", takze kdyz 1 znak nazvu '.', tak preskocit
	;
	sbiw	R30,0xB	;na 1 znak nazvu
	;hodit cely vstup do zasobniku LFN
	ldi	R20,32
SaveEntryFfSF:	ld	R21,Z+
	st	Y+,R21
	dec	R20
	brne	SaveEntryFfSF
	rcall	CheckEStackEnd	;test na konec zasobniku vstupu
	;
	sbiw	R30,0x20-0xB	;zpet na atribut
	;
	rcall	PrintFFname	;vypis jmena
	rcall	LFNinitBuffer	;reinicializace LFN bufferu
	;
	ld	R16,Z	;atribut
	bst	R16,4	;je to adresar?
	brtc	LoadSFErEnt
	;je to adresar
	adiw	R30,0xF
	ld	R16,Z+
	ld	R17,Z+	;1. cluster adresare do R16:R17
	sbiw	R30,0x11
	rcall	SubFoldPrint	;volat rekurzivni fci na vypis obsahu podadresare
	rcall	LFNinitBuffer	;reinicializace LFN bufferu
	;
LoadSFErEnt:	sbiw	R30,0xB	;na zacatek vstupu
	;hodit cely vstup do zasobniku LFN
	ldi	R20,32
SaveEntryFoSF:	ld	R21,Z+
	st	Y+,R21
	dec	R20
	brne	SaveEntryFoSF
	rcall	CheckEStackEnd	;test na konec zasobniku vstupu
	;
	dec	R25
	brne	NextSFEntry	;dalsi vstup
	;
	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;LBA adresa dalsiho sektoru
	;
	dec	R24
	brne	NextSFSector	;dalsi sektor clusteru
	ret



;-----------------------------------------------------------------------------------------------------------------------
;	inicializace LFN bufferu pro cteni dlouhych jmen
;-----------------------------------------------------------------------------------------------------------------------
LFNinitBuffer:	rcall	ClrLFNbuffer
	ldi	R28,low(DataBuffer+512)	;od teto adresy do adresy +768 se zapisuje poslednich 8 vstupu
	ldi	R29,high(DataBuffer+512)	;po nalezeni vstupu souboru se z tohoto zasobniku nacte dlouhy nazev
	ret	
;-----------------------------------------------------------------------------------------------------------------------
;	vymazat DataBuffer
;-----------------------------------------------------------------------------------------------------------------------
ClrDataBuffer:	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	ldi	R28,low(BufferSize)
	ldi	R29,high(BufferSize)
	ldi	R16,0
UnGarbageDB:	st	Z+,R16
	subi	R28,1
	sbci	R29,0
	brne	UnGarbageDB
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vymazat LFN buffer
;-----------------------------------------------------------------------------------------------------------------------
ClrLFNBuffer:	push	R28
	push	R29
	push	R30
	push	R31
	ldi	R30,low(DataBuffer+512)
	ldi	R31,high(DataBuffer+512)
	ldi	R28,low(512)
	ldi	R29,high(512)
	ldi	R16,0
UnGarbageLFNB:	st	Z+,R16
	subi	R28,1
	sbci	R29,0
	brne	UnGarbageLFNB
	pop	R31
	pop	R30
	pop	R29
	pop	R28
	ret
;***********************************************************************************************************************
;	tady by mely byt vsechny rutiny pro praci s IDE apod.
;***********************************************************************************************************************
WaitInitIDE:	;nejdiv cakat na BUSY
	rcall	LCDclrAll
	ldi	R30,low(TextWaitBSYT*2)
	ldi	R31,high(TextWaitBSYT*2)
	rcall	LCDwrStrFLASH	;vypis na LCD
	ldi	R30,low(TextWaitBSYT*2)
	ldi	R31,high(TextWaitBSYT*2)
	rcall	PrintStrFLASH
	rcall	TermBreakLine
	;
	rcall	WaitDriveBSY	;cekat az je HDD/CF ready prijimat instrukce
	;ted cekat na "drive ready"
	rcall	LCDclrAll
	ldi	R30,low(TextWaitDRYT*2)
	ldi	R31,high(TextWaitDRYT*2)
	rcall	LCDwrStrFLASH	;vypis na LCD
	ldi	R30,low(TextWaitDRYT*2)
	ldi	R31,high(TextWaitDRYT*2)
	rcall	PrintStrFLASH
	rcall	TermBreakLine
	;
	rcall	WaitDriveRDY	;u HDD jeste cekat na roztoceni
	ret
;-----------------------------------------------------------------------------------------------------------------------	
;	nacte sektor LBA R7:R8:R9:R10 do zasobniku
;-----------------------------------------------------------------------------------------------------------------------
RDsectorLBA:	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	;
	rcall	SetLBAadressRD
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	rcall	RDdriveSektor
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nastavi adresu v LBA modu
;-----------------------------------------------------------------------------------------------------------------------
SetLBAadressCom:	rcall	WaitDriveBSY
	;D0-D7 jako vystup
	ldi	R16,0b11111111
	out	ddrc,R16
	;pocet sektoru pro pristi zapis/cteni
	ldi	R16,0b10100000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R6	;pocet sektoru zapisovanych najednou
	rcall	IOWRpulz
	;LBA A0-A7 (sektor)
	ldi	R16,0b10110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R7	;LBA A0-A7
	rcall	IOWRpulz
	;LBA A8-A15 (cylindr low)
	ldi	R16,0b11000000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R8	;LBA A8-A15
	rcall	IOWRpulz
	;LBA A16-A23 (cylindr high)
	ldi	R16,0b11010000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R9	;LBA A16-A23
	rcall	IOWRpulz
	;LBA A24-A27 (SDH registr)
	ldi	R16,0b11100000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0b11000000	;LBA mod
	or	R16,R10	;LBA A24-A27
	out	portc,R16
	rcall	IOWRpulz
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nastavi LBA adresu a vysle instrukci cteni sektoru
;-----------------------------------------------------------------------------------------------------------------------
SetLBAadressRD:	ldi	R16,1	;pocet sektoru
	mov	R6,R16
	rcall	SetLBAadressCom
	rcall	WaitDriveBSY
	;cti sektor
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0x20	;cti sektor
	out	portc,R16
	rcall	IOWRpulz
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	cekat dokud je HDD busy
;-----------------------------------------------------------------------------------------------------------------------
WaitDriveBSY:	rcall	SetDriveStatReg
WaitDriveBSY1:	rcall	ReadDriveStat
	bst	R16,7
	brts	WaitDriveBSY1
	out	ddrc,R17
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	cekat na data z HDD
;-----------------------------------------------------------------------------------------------------------------------
WaitDataReady:	rcall	SetDriveStatReg
WaitDataReady1:	rcall	ReadDriveStat
	bst	R16,3
	brtc	WaitDataReady1
	out	ddrc,R17
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	cekat dokud neni HDD ready
;-----------------------------------------------------------------------------------------------------------------------
WaitDriveRDY:	rcall	SetDriveStatReg
WaitDriveRDY1:	rcall	ReadDriveStat
	bst	R16,6
	brtc	WaitDriveRDY1
	out	ddrc,R17
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	cist stav 
;-----------------------------------------------------------------------------------------------------------------------
ReadDriveStat:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	in	R16,pinc
	sbi	portd,3
	nop
	nop
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nastavit status registr
;-----------------------------------------------------------------------------------------------------------------------
SetDriveStatReg:	in	R17,ddrc
	ldi	R16,0b11111111
	out	portc,R16
	ldi	R16,0b00000000
	out	ddrc,R16
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nastavit datovy registr
;-----------------------------------------------------------------------------------------------------------------------
SetDriveDataReg:	ldi	R16,0b10000000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	pulz na IOWR
;-----------------------------------------------------------------------------------------------------------------------
IOWRpulz:	nop
	cbi	portd,7
	nop
	nop
	nop
	nop
	nop
	nop
	sbi	portd,7
	nop
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	precte 1 sektor
;-----------------------------------------------------------------------------------------------------------------------
RDdriveSektor:	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	;
	ldi	R18,128	;256 slov
RDsectorR:	cbi	portd,3
	nop
	nop
	dec	R18
	in	R17,pina
	in	R16,pinc
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	;
	cbi	portd,3
	nop
	nop
	nop
	in	R17,pina
	in	R16,pinc
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	brne	RDsectorR
	;
	ldi	R16,0b11111111
	out	ddra,R16
	out	ddrc,R16
	;
	ret
;------------------------------------------------------------------------------------------------------------------------
;	nastavi fyzickou geometrii disku, z identifikacniho retezce
;------------------------------------------------------------------------------------------------------------------------
SetDriveParam:	ldi	R30,low(DataBuffer+6)
	ldi	R31,high(DataBuffer+6)
	ld	R10,Z+	;pocet hlav
	dec	R10	;(pocet hlav)-1
	adiw	R30,5
	ld	R6,Z+	;pocet sektoru na stopu
	;
	rcall	SetLBAadressCom
	rcall	WaitDriveBSY
	;
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0x91	;Set Drive Parameters
	out	portc,R16
	rcall	IOWRpulz
	rcall	WaitDriveBSY
	ret
;------------------------------------------------------------------------------------------------------------------------	
;	identifikace zarizeni na IDE
;------------------------------------------------------------------------------------------------------------------------
IdentIDEdrive:	ldi	R16,0b11111111
	out	ddrc,R16
	;cekat na roztoceni disku
	rcall	WaitDriveRDY
	;command registr
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	;
	ldi	R16,0xEC	;identifikace
	out	portc,R16
	rcall	IOWRpulz
	;
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	ldi	R16,0b11111111	;zvedaci odpory
	out	porta,R16
	out	portc,R16
	;
	ldi	R19,0	;256 slov do zasobniku
ReadIdentSector:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	in	R17,pina	;nacist high byte
	in	R16,pinc	;nacist low byte
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	dec	R19
	brne	ReadIdentSector
	;
	ldi	R16,0b11111111
	out	ddrc,R16
	out	ddra,R16
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vypis nekterych parametru CF/HDD
;-----------------------------------------------------------------------------------------------------------------------	
PrintHDDident:	ldi	R30,low(TextIDEparT*2)
	ldi	R31,high(TextIDEparT*2)
	rcall	PrintHDLN	;titulek
	;model number
	ldi	R30,low(TextMNT*2)
	ldi	R31,high(TextMNT*2)
	rcall	PrintStrFLASH
	ldi	R30,low(DataBuffer+54)
	ldi	R31,high(DataBuffer+54)
	ldi	R17,20
	rcall	PrintStrRAMrev
	rcall	TermBreakLine	;zalomit lajnu
	;serial number
	ldi	R30,low(TextSNT*2)
	ldi	R31,high(TextSNT*2)
	rcall	PrintStrFLASH
	ldi	R30,low(DataBuffer+20)
	ldi	R31,high(DataBuffer+20)
	ldi	R17,10
	rcall	PrintStrRAMrev
	rcall	TermBreakLine	;zalomit lajnu
	;verze radice
	ldi	R30,low(TextFWT*2)
	ldi	R31,high(TextFWT*2)
	rcall	PrintStrFLASH
	ldi	R30,low(DataBuffer+46)
	ldi	R31,high(DataBuffer+46)
	ldi	R17,4
	rcall	PrintStrRAMrev
	rcall	TermBreakLine	;zalomit lajnu
	;cylindru
	ldi	R30,low(TextCylsT*2)
	ldi	R31,high(TextCylsT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+2+0
	lds	R17,DataBuffer+2+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	;hlav
	ldi	R30,low(TextHeadsT*2)
	ldi	R31,high(TextHeadsT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+6+0
	lds	R17,DataBuffer+6+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	;sektoru na stopu
	ldi	R30,low(TextSPTT*2)
	ldi	R31,high(TextSPTT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+12+0
	lds	R17,DataBuffer+12+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	;celkova kapacita v CHS adresaci v sektorech
	ldi	R30,low(TextCHSkapT*2)
	ldi	R31,high(TextCHSkapT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+12+0
	lds	R17,DataBuffer+6+0
	mul	R16,R17
	movw	R20,R0
	lds	R22,DataBuffer+2+0
	lds	R23,DataBuffer+2+1
	rcall	mul16u
	rcall	bin2BCD32p10
	rcall	USRwrBCD32
	rcall	TermBreakLine	;zalomit lajnu
	;celkova kapacita v LBA adresaci v sektorech
	ldi	R30,low(TextLBAkapT*2)
	ldi	R31,high(TextLBAkapT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+120+0
	lds	R17,DataBuffer+120+1
	lds	R18,DataBuffer+120+2
	lds	R19,DataBuffer+120+3
	rcall	bin2BCD32p10
	rcall	USRwrBCD32
	rcall	TermBreakLine	;zalomit lajnu
	;a ted v MB
	ldi	R30,low(TextLBAkapMBT*2)
	ldi	R31,high(TextLBAkapMBT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+120+0
	lds	R17,DataBuffer+120+1
	lds	R18,DataBuffer+120+2
	lds	R19,DataBuffer+120+3
	ldi	R20,low(2048)
	ldi	R21,high(2048)
	ldi	R22,byte3(2048)
	ldi	R23,byte4(2048)
	rcall	div32uc2
	rcall	bin2BCD24p8
	rcall	USRwrBCD24
	ldi	R30,low(TextMBT*2)
	ldi	R31,high(TextMBT*2)
	rcall	PrintStrFLASH
	rcall	TermBreakLine	;zalomit lajnu
	rcall	TermBreakLine	;zalomit lajnu
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	pricte k LBA adrese 16bit cislo R16:R17
;-----------------------------------------------------------------------------------------------------------------------
LBAadressAdd16:	clr	R15
	add	R7,R16
	adc	R8,R17
	adc	R9,R15
	adc	R10,R15
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	pricte k LBA adrese 24bit cislo R23:R24:R25
;-----------------------------------------------------------------------------------------------------------------------
LBAadressAdd24:	clr	R15
	add	R7,R23
	adc	R8,R24
	adc	R9,R25
	adc	R10,R15
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	pricte k LBA adrese 32bit cislo R0:R1:R2:R3
;-----------------------------------------------------------------------------------------------------------------------
LBAadressAdd32:	add	R7,R0
	adc	R8,R1
	adc	R9,R2
	adc	R10,R3
	ret
;***********************************************************************************************************************
;	rutiny pro praci s FAT16
;***********************************************************************************************************************
;-----------------------------------------------------------------------------------------------------------------------
;	nacte adresy 1. FAT, root adresare, zacatku dat a zapise velikost clusteru
;-----------------------------------------------------------------------------------------------------------------------
ReadFATparam:	clr	R7
	clr	R8
	clr	R9
	clr	R10	;zacatek HDD (LBA 0)
	rcall	RDsectorLBA
	;executable mark
	lds	R16,DataBuffer+0x1FE
	lds	R17,DataBuffer+0x1FF
	ldi	R18,0x55
	ldi	R19,0xAA
	cp	R16,R18
	cpc	R17,R19
	breq	MasterBootROk
	;master boot record nenalezen
	rjmp	MBRnotFound
	;master boot record nalezen
MasterBootROk:	lds	R16,DataBuffer+0x1BE+0x4	;typ partition
	cpi	R16,0x4	;je to FAT16
	breq	MBR1partFAT16
	cpi	R16,0x6	;je to FAT16
	breq	MBR1partFAT16
	;neni to FAT16
	rjmp	MBR1partNotF16
	;je to FAT16
MBR1partFAT16:	lds	R16,DataBuffer+0x1BE+0x8+0
	lds	R17,DataBuffer+0x1BE+0x8+1	;mezera pred boot recordem 1.partition
	rcall	LBAadressAdd16	;jeji LBA
	;
	rcall	RDsectorLBA	;nacist 1.partition boot record
	;executable mark
	lds	R16,DataBuffer+0x1FE
	lds	R17,DataBuffer+0x1FF
	ldi	R18,0x55
	ldi	R19,0xAA
	cp	R16,R18
	cpc	R17,R19
	breq	FAT16BRok
	;FAT16 boot record nenalezen
	rjmp	FAT16BRnotF
	;FAT16 boot record nalezen
FAT16BRok:	lds	R16,DataBuffer+0xD	;velikost clusteru v sektorech
	sts	SecPerCluster,R16
	lds	R16,DataBuffer+0x11+0
	lds	R17,DataBuffer+0x11+1	;pocet vstupu do root adresare
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16	;delit 16x na pocet sektoru
	sts	RootDirSectors,R16	;ulozit pocet sektoru root adresare
	lds	R16,DataBuffer+0xE+0
	lds	R17,DataBuffer+0xE+1	;pocet sektoru pred 1. FAT
	rcall	LBAadressAdd16
	sts	FAT1LBAadress,R7
	sts	FAT1LBAadress+1,R8
	sts	FAT1LBAadress+2,R9
	sts	FAT1LBAadress+3,R10	;LBA adresa 1.FAT
	lds	R20,DataBuffer+0x16+0
	lds	R21,DataBuffer+0x16+1	;pocet sektoru v 1 FAT 
	lds	R22,DataBuffer+0x10	;pocet FAT
	clr	R23
	rcall	mul16u
	rcall	LBAadressAdd16
	sts	RootLBAadress,R7
	sts	RootLBAadress+1,R8
	sts	RootLBAadress+2,R9
	sts	RootLBAadress+3,R10	;LBA adresa root adresare
	;
	lds	R16,RootDirSectors
	clr	R17
	rcall	LBAadressAdd16
	sts	DataLBAadress,R7
	sts	DataLBAadress+1,R8
	sts	DataLBAadress+2,R9
	sts	DataLBAadress+3,R10	;LBA adresa zacatku dat
	ret
;-----------------------------------------------------------------------------------------------------------------------
	;chybi MBR
MBRnotFound:	ldi	R30,low(TextMBRnfT*2)
	ldi	R31,high(TextMBRnfT*2)
	rcall	PrintStrFLASH
	rcall	LCDclrAll
	ldi	R30,low(TextMBRnfT*2)
	ldi	R31,high(TextMBRnfT*2)
	rcall	LCDwrStrFLASH
	rjmp	PC
;-----------------------------------------------------------------------------------------------------------------------
	;1.partition neni FAT16
MBR1partNotF16:	ldi	R30,low(TextNF16T*2)
	ldi	R31,high(TextNF16T*2)
	rcall	PrintStrFLASH
	rcall	LCDclrAll
	ldi	R30,low(TextNF16T*2)
	ldi	R31,high(TextNF16T*2)
	rcall	LCDwrStrFLASH
	ldi	R16,0xA
	rcall	PrintChar
	ldi	R30,low(TextNF16fT*2)
	ldi	R31,high(TextNF16fT*2)
	rcall	PrintStrFLASH
	ldi	R16,0b11000000
	rcall	LCDsetPos
	ldi	R30,low(TextNF16fT*2)
	ldi	R31,high(TextNF16fT*2)
	rcall	LCDwrStrFLASH
	;napis co to je partition
	rcall	IdentFSf32
	rjmp	PC
;-----------------------------------------------------------------------------------------------------------------------
	;FAT16 boot record nema executable mark	
FAT16BRnotF:	ldi	R30,low(TextF16brnT*2)
	ldi	R31,high(TextF16brnT*2)
	rcall	PrintStrFLASH
	rcall	LCDclrAll
	ldi	R30,low(TextF16brnT*2)
	ldi	R31,high(TextF16brnT*2)
	rcall	LCDwrStrFLASH
	rjmp	PC
;-----------------------------------------------------------------------------------------------------------------------
	;identifikace typu 1.partition	
IdentFSf32:	ldi	R30,low(FStableT*2)
	ldi	R31,high(FStableT*2)
	lds	R16,DataBuffer+0x1BE+0x4	;filesystem
	;najit retezec v tabulce podle systemu
IdentFSf32fn1:	lpm	R17,Z+
	cp	R17,R16
	breq	IdentFSf32ok
	cpi	R17,0xFF
	breq	IdentFSf32ok
IdentFSf32fnext:	lpm	R17,Z+
	cpi	R17,0xFF
	brne	IdentFSf32fnext
	rjmp	IdentFSf32fn1
	;nalezeno, Z ukazuje na text
IdentFSf32ok:	push	R30
	push	R31
	call	PrintStrFLASH
	pop	R31
	pop	R30
	rcall	LCDwrStrFLASH
	ret
FStableT:	.db	0x00,"zadna ",0xFF
	.db	0x01,"FAT12 ",0xFF
	.db	0x07,"NTFS",0xFF
	.db	0x0B,"FAT32 ",0xFF
	.db	0x0C,"FAT32 ",0xFF
	.db	0x86,"NTFS",0xFF
	.db	0x87,"NTFS",0xFF
	.db	0xFF,"neznama ",0xFF	;konec
;-----------------------------------------------------------------------------------------------------------------------
;	vypis nekterych parametru FAT16 na terminal
;-----------------------------------------------------------------------------------------------------------------------
PrintFATident:	ldi	R30,low(TextFATparT*2)
	ldi	R31,high(TextFATparT*2)
	rcall	PrintHDLN	;titulek
	;disk label
	ldi	R30,low(TextDLT*2)
	ldi	R31,high(TextDLT*2)
	rcall	PrintStrFLASH
	ldi	R30,low(DataBuffer+0x2B)
	ldi	R31,high(DataBuffer+0x2B)
	ldi	R17,11
	rcall	PrintStrRAM
	rcall	TermBreakLine	;zalomit lajnu
	;OEM
	ldi	R30,low(TextOEMT*2)
	ldi	R31,high(TextOEMT*2)
	rcall	PrintStrFLASH
	ldi	R30,low(DataBuffer+0x3)
	ldi	R31,high(DataBuffer+0x3)
	ldi	R17,8
	rcall	PrintStrRAM
	rcall	TermBreakLine	;zalomit lajnu
	;velikost clusteru
	ldi	R30,low(TextCST*2)
	ldi	R31,high(TextCST*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+0x0D
	lsr	R16
	cpi	R16,0
	brne	CS512Bn
	;velikost je 0.5kB - napsat retezcem
	ldi	R30,low(TextCS512T*2)
	ldi	R31,high(TextCS512T*2)
	rcall	PrintStrFLASH
	rjmp	CS512B
CS512Bn:	clr	R17
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	ldi	R30,low(TextkBT*2)
	ldi	R31,high(TextkBT*2)
	rcall	PrintStrFLASH
CS512B:	rcall	TermBreakLine	;zalomit lajnu
	;ted pocet clusteru, nejdriv vypocet poctu sektoru v datove oblasti
	ldi	R30,low(TextCCT*2)
	ldi	R31,high(TextCCT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+0x13+0
	lds	R17,DataBuffer+0x13+1
	clr	R18
	clr	R19
	cp	R16,R18
	cpc	R17,R18
	brne	CCm32MB
	lds	R16,DataBuffer+0x20+0
	lds	R17,DataBuffer+0x20+1
	lds	R18,DataBuffer+0x20+2
	lds	R19,DataBuffer+0x20+3
	;ted mame pocet sektoru v partition
CCm32MB:	lds	R20,DataBuffer+0x16+0
	lds	R21,DataBuffer+0x16+1	;velikost 1 FAT v sektorech
	lds	R22,DataBuffer+0x10+0	;pocet FAT
	clr	R23
	mul	R21,R22
	movw	R4,R0
	mul	R20,R22
	mov	R3,R0
	add	R4,R1
	adc	R5,R23	;celkem ve FAT
	lds	R20,DataBuffer+0x0E+0
	lds	R21,DataBuffer+0x0E+1	;mezera pred FAT
	lds	R22,RootDirSectors	;sektoru v root
	clr	R0
	add	R20,R22
	adc	R21,R0
	clr	R22
	add	R20,R3
	adc	R21,R4
	adc	R22,R5
	sub	R16,R20
	sbc	R17,R21
	sbc	R18,R22
	sbc	R19,R0	;ted uz vypocet sektoru v datech
	movw	R0,R16
	movw	R2,R18	;a zaloha cisla
	lds	R20,DataBuffer+0x0D	;velikost clusteru
	clr	R21
	clr	R22
	clr	R23
	rcall	div32uc2	;podelit na pocet clusteru 
	rcall	bin2BCD16p5	;na BCD
	rcall	USRwrBCD16	;a vypsat
	rcall	TermBreakLine	;zalomit lajnu
	;ted velikost FAT16 v datove oblasti ciselne
	ldi	R30,low(TextPSizT*2)
	ldi	R31,high(TextPSizT*2)
	rcall	PrintStrFLASH
	movw	R16,R0
	movw	R18,R2	;obnova poctu sektoru
	ldi	R20,low(2048)
	ldi	R21,high(2048)
	ldi	R22,byte3(2048)
	ldi	R23,byte4(2048)
	rcall	div32uc2	;podelit na MB
	rcall	bin2BCD16p5
	rcall	USRwrBCD16	;vypsat
	ldi	R30,low(TextMBT*2)
	ldi	R31,high(TextMBT*2)
	rcall	PrintStrFLASH
	rcall	TermBreakLine	;zalomit lajnu
	;pocet FAT
	ldi	R30,low(TextFATCT*2)
	ldi	R31,high(TextFATCT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+0x10+0
	clr	R17
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	;velikost 1 FAT
	ldi	R30,low(TextFATlenT*2)
	ldi	R31,high(TextFATlenT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+0x16+0
	lds	R17,DataBuffer+0x16+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	;vstupu do root
	ldi	R30,low(TextRootEntrT*2)
	ldi	R31,high(TextRootEntrT*2)
	rcall	PrintStrFLASH
	lds	R16,DataBuffer+0x11+0
	lds	R17,DataBuffer+0x11+1
	rcall	bin2BCD16p5
	rcall	USRwrBCD16
	rcall	TermBreakLine	;zalomit lajnu
	rcall	TermBreakLine	;zalomit lajnu
	ret
;-----------------------------------------------------------------------------------------------------------------------	
;	nacist FAT do externi SRAM od adresy 0x00000 do 0x80000 (128kB)
;-----------------------------------------------------------------------------------------------------------------------
CopyFATextSRAM:	clr	R3
	clr	R4
	clr	R5
	rcall	LoadFAT1LBAad
	ldi	R24,0	;256 sektoru
CopyFAT:	rcall	RDsectorLBA
	rcall	SectorToSRAMext
	ldi	R16,1
	clr	R17
	rcall	LBAadressAdd16	;dalsi sektor
	dec	R24
	brne	CopyFAT
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	test na naplneni zasobniku poslednich vstupu, pak reset ukazatele na zacatek
;-----------------------------------------------------------------------------------------------------------------------
CheckEStackEnd:	ldi	R18,low(DataBuffer+768)
	ldi	R19,high(DataBuffer+768)	;konec zasobniku
	cp	R28,R18
	cpc	R29,R19
	brne	EndESReached
	ldi	R28,low(DataBuffer+512)
	ldi	R29,high(DataBuffer+512)	;reset ukazatele zasobniku
EndESReached:	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nacte LFN nazev nebo SFN nazev pokud LFN neni
;	ke sve funkci musi mit vsechny casti LFN v Bufferu a Y musi ukazovat na konec zakladniho vstupu
;	tyto casti se ukladaji v prubehu prochazeni adresare - musis se zecit prochazet alespon 8 polozek 
;	pred zakladnim vstupem, takze neni mozne pristupovat primo k vybranemu zakladnimu vstupu 
;-----------------------------------------------------------------------------------------------------------------------
ReadLongName:	ldi	R20,low(DataBuffer+512)
	ldi	R21,high(DataBuffer+512)	;zacatek zasobniku
	rcall	DecEntryNumber	;navrat na zacatek kratkeho vstupu
	;nejdiv nacist kratky nazev
	rcall	LoadShortName
	;na 1. cast dlouheho nazvu
	rcall	DecEntryNumber
	;ted test, jestli tam vubec je LFN nazev
	adiw	R28,0xB	;atribut
	ld	R16,Y
	sbiw	R28,0xB
	cpi	R16,0xF
	brne	LFNnok	;neni to LFN
	ld	R16,Y
	cpi	R16,0xE5
	breq	LFNnok	;smazany vstup
	cpi	R16,0x01
	breq	LFNok	;je tam dlouhy nazev (prvni cast (a neni posledni :-))
	cpi	R16,0x41
	breq	LFNok	;je tam dlouhy nazev (posledni jeho cast (je tam jen 1 cast presneji receno))
	;dlouhy nazev neni
LFNnok:	rjmp	NotLFNfound
	;dlouhy nazev je
LFNok:	ldi	R30,low(EntryNameString)
	ldi	R31,high(EntryNameString)	;ukazatel na zasobnik nazvu
	clt		;priznak konce nazvu - nebylo dosazeno konce
	clr	R18	;nulovat pocet znaku nazvu
	;
NextPartOfEntry:	ld	R19,Y+	;poradove cislo teto casti nazvu
	ldi	R20,5	;5 pismen
	rcall	CopyFewChars	;do bufferu
	adiw	R28,3
	ldi	R20,6	;6 pismen
	rcall	CopyFewChars	;do bufferu
	adiw	R28,2
	ldi	R20,2	;2 pismena
	rcall	CopyFewChars	;do bufferu
	rcall	DecEntryNumber
	rcall	DecEntryNumber	;na predchozi cast nazvu (na dalsi cast ve skutecnosti)
	cpi	R19,0x40	;kdyz je k poradovemu cislu pricteno 40h
	brcs	NextPartOfEntry
	;tak je nazev nacten kompletne
NotLFNfound:	sts	EntryNameLen,R18	;ulozit pocet znaku nazvu
	;vyplnit zbytek nazvu mezerami
	rcall	SongNameEnd0
	ret
	;nacteni krakeho jmena
LoadShortName:	ldi	R30,low(EntryNameString)
	ldi	R31,high(EntryNameString)	;ukazatel na zasobnik nazvu
	;nazev
	ldi	R17,8	;fixne 8 znaku nazvu
CopyShortEName:	ld	R16,Y+
	st	Z+,R16
	dec	R17
	brne	CopyShortEName	;dalsi znak
	;odstranit mezery na konci pokud neni plnych 8 znaku 
	rcall	SFNdeSpace
	;tecka
	ldi	R17,'.'
	st	Z+,R17	;hodit tam tecku
	;pripona
	ld	R16,Y
	cpi	R16,' '
	brne	CopyShortEName2
	;kdyz neni pripona tak smazat tecku
	sbiw	R30,1
	ldi	R16,' '
	st	Z+,R16
	;
CopyShortEName2:	ldi	R17,3	;3 znaky pripony
CopyShortEName1:	ld	R16,Y+
	st	Z+,R16
	dec	R17
	brne	CopyShortEName1	;dalsi znak
	;
	sbiw	R28,11	;navrat na zacatek vstupu
	ldi	R18,12	;nazev je dlouhy 12 znaku
	sub	R18,R19
	ret
	;odstranit mezery za nazvem
SFNdeSpace:	ldi	R19,0	;odstraneno 0 mezer
SFNdeSpace1:	ld	R16,-Z
	inc	R19
	cpi	R16,' '
	breq	SFNdeSpace1
	adiw	R30,1
	dec	R19
	ret
;------------------------------------------------------------------------------------------------------------------------	
;	vyplnit zbytek nazvu mezerami
;------------------------------------------------------------------------------------------------------------------------
SongNameEnd0:	ldi	R18,low(EntryNameString+92)
	ldi	R19,high(EntryNameString+92)	;ukazatel na zasobnik nazvu
	ldi	R16,' '
FillSpaces:	st	Z+,R16
	cp	R30,R18
	cpc	R31,R19
	brne	FillSpaces
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	kopiruje R17 pismen nazvu, prevadi podstatne znaky UTF16 do CP1250 
;-----------------------------------------------------------------------------------------------------------------------		
CopyFewChars:	ld	R16,Y+
	ld	R17,Y
	rcall	UTF16toCP1250	;prevod do CP1250
	brts	NotCopyFewChars
	cpi	R16,0x00
	breq	CopyFewChars3
	cpi	R16,0xFF
	brne	CopyFewChars1
CopyFewChars3:	adiw	R28,1
	set
	rjmp	CopyFewChars2
CopyFewChars1:	st	Z+,R16
	inc	R18	;pocet znaku nazvu
CopyFewChars2:	adiw	R28,1
	dec	R20
	brne	CopyFewChars
NotCopyFewChars:	ret
;-----------------------------------------------------------------------------------------------------------------------
;	navrat o vstup zpet
;-----------------------------------------------------------------------------------------------------------------------	
DecEntryNumber:	cp	R28,R20
	cpc	R29,R21
	brne	EntStackStart
	;kdyz je na zacatku, tak nahrat konec - 32
	ldi	R28,low(DataBuffer+768)
	ldi	R29,high(DataBuffer+768)	;konec zasobniku
EntStackStart:	sbiw	R28,32	;o vstup zpet
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	rutina pro prevod znaku v UTF16 (R16:R17) do kodovani CP1250 (R16:R17)
;-----------------------------------------------------------------------------------------------------------------------
UTF16toCP1250:	cpi	R17,0
	brne	UTF16_more255
	cpi	R16,128
	brcc	UTF16_128_255
	;UTF16 znak ma hodnotu 0-127 - zustava nemenny
	ret
	;UTF16 znak ma hodnotu 128-255 - prekodovat podle 1.tabulky
UTF16_128_255:	push	R30
	push	R31
	ldi	R30,low(UTF16toCP1250T1*2)
	ldi	R31,high(UTF16toCP1250T1*2)	;1.tabulka
	subi	R16,(128+32)	;prvnich 32 znaku teto skupiny neni definovano
	add	R30,R16
	adc	R31,R17	;adresa hledaneho znaku v tabulce
	lpm	R16,Z+	;nacist ho a hotovo
	pop	R31
	pop	R30
	ret
	;UTF16 znak ma hodnotu vic nez 255 - vyhledat patricny znak v tabulce 2
UTF16_more255:	push	R18
	push	R19
	push	R30
	push	R31
	ldi	R30,low(UTF16toCP1250T2*2)
	ldi	R31,high(UTF16toCP1250T2*2)	;2.tabulka
	;smycka pro porovnavani hodnot tabulky
UTF16_more255n2:	lpm	R18,Z+
	lpm	R19,Z+
	cp	R16,R18
	cpc	R17,R19
	brne	UTF16_more255n1
	;nalezeno
	lpm	R16,Z+
	lpm	R17,Z+
	cpi	R17,0x00
	breq	UTF16_more255f
	;ale je to uz mimo tabulku,takze R16=0x00
	clr	R16
	rjmp	UTF16_more255f
UTF16_more255n1:	sbiw	R30,2
	lpm	R18,Z+
	adiw	R30,1
	cpi	R18,0xFF	;neni to uz konec tabulky?
	brne	UTF16_more255n2	;ne
	;hotovo
UTF16_more255f:	pop	R31
	pop	R30
	pop	R19
	pop	R18
	ret
;prevodni tabulka pro znaky UTF16 do CP1250 v rozmezi 160-255
UTF16toCP1250T1:	.db	0,0,0,0
	.db	0,0,'|',''
	.db	'',169,0,0
	.db	0,32,174,0
	.db	'',0xB1,0,0
	.db	'',0,0,0
	.db	0,0,0,0
	.db	0,0,0,0
	.db	0,'',0,0
	.db	'',0,0,0
	.db	0,'',0,''
	.db	0,'',0,0
	.db	0,0,0,''
	.db	0,0,'','*'
	.db	0,0,'',0
	.db	'','',0,0
	.db	0,'',0,0
	.db	'',0,0,0
	.db	0,'',0,''
	.db	0,'',0,0
	.db	0,0,0,''
	.db	0,0,'',':'
	.db	0,0,'',0
	.db	'','',0,0
	;prevodni tabulka pro znaky UTF16 do CP1250 vyssi nez 255
UTF16toCP1250T2:	.dw	0x0160,0x008A	;S hacek
	.dw	0x0164,0x008D	;T hacek
	.dw	0x017D,0x008E	;Z hacek
	.dw	0x0161,0x009A	;s hacek
	.dw	0x0165,0x009D	;t hacek
	.dw	0x017E,0x009E	;z hacek
	.dw	0x02C7,0x00A1	;hacek
	.dw	0x010C,0x00C8	;C hacek
	.dw	0x011A,0x00CC	;E hacek
	.dw	0x010E,0x00CF	;D hacek
	.dw	0x0147,0x00D2	;N hacek
	.dw	0x0158,0x00D8	;R hacek
	.dw	0x016E,0x00D9	;U krouzek
	.dw	0x010D,0x00E8	;c hacek
	.dw	0x011B,0x00EC	;e hacek
	.dw	0x010F,0x00EF	;d hacek
	.dw	0x0148,0x00F2	;n hacek
	.dw	0x0159,0x00F8	;r hacek
	.dw	0x016F,0x00F9	;u krouzek
	.dw	0x0000,0xFF00	;zakonceni tabulky
;-----------------------------------------------------------------------------------------------------------------------
;	nahrat LBA adresu 1.FAT
;-----------------------------------------------------------------------------------------------------------------------
LoadFAT1LBAad:	lds	R7,FAT1LBAadress+0
	lds	R8,FAT1LBAadress+1
	lds	R9,FAT1LBAadress+2
	lds	R10,FAT1LBAadress+3
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nahrat LBA adresu root adresare
;-----------------------------------------------------------------------------------------------------------------------
LoadRootLBAad:	lds	R7,RootLBAadress+0
	lds	R8,RootLBAadress+1
	lds	R9,RootLBAadress+2
	lds	R10,RootLBAadress+3
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nahrat LBA adresu prvniho sektoru dat
;-----------------------------------------------------------------------------------------------------------------------
LoadDataLBAad:	lds	R7,DataLBAadress+0
	lds	R8,DataLBAadress+1
	lds	R9,DataLBAadress+2
	lds	R10,DataLBAadress+3
	ret
;***********************************************************************************************************************
;	Rutiny pro praci s externi SRAM
;***********************************************************************************************************************
;-----------------------------------------------------------------------------------------------------------------------
;	kopiruje 512B zasobniku interni RAM do exteri na adresu od R3:R4:R5
;-----------------------------------------------------------------------------------------------------------------------
SectorToSRAMext:	ldi	R30,low(DataBuffer)
	ldi	R31,high(DataBuffer)
	clr	R14
	inc	R14
	clr	R15
	ldi	R17,0
	ldi	R18,2	;512B
SecToSRAMext1:	ld	R16,Z+
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	dec	R17
	brne	SecToSRAMext1
	dec	R18
	brne	SecToSRAMext1
	ret
;-----------------------------------------------------------------------------------------------------------------------	
;	nacte word ze SRAM z adresy R11:R12:R13 do R16:R17, inkrementuje adresu 
;-----------------------------------------------------------------------------------------------------------------------
LoadSRAMword:	clr	R14
	inc	R14
	clr	R15
	out	ddrc,R15
	cbi	portd,4
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R16,pinc
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R17,pinc
	;	
	sbi	portd,4
	dec	R15
	out	ddrc,R15
	ret
;***********************************************************************************************************************
;	rutiny pro USART
;***********************************************************************************************************************
;-----------------------------------------------------------------------------------------------------------------------
;	odesle pres USART R17 znaku od ukazatele Z z RAM
;-----------------------------------------------------------------------------------------------------------------------
PrintStrRAM:	ldi	R16,0b00001000	;timer 0 - stop
	out	tccr0,R16
	;
PrintStrRAM1:	sbis	ucsra,udre
	rjmp	PrintStrRAM1	;cekat na vyprazdneni zasobniku
	ld	R16,Z+
	out	udr,R16
	dec	R17	;dalsi znak
	brne	PrintStrRAM1
	;
	ldi	R16,0b00001011	;timer 0 - delitel XTAL/64
	out	tccr0,R16	
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	odesle pres USART R17/2 znaku od ukazatele Z z RAM, prohazuje dvojice sousednich B
;-----------------------------------------------------------------------------------------------------------------------	
PrintStrRAMrev:	adiw	R30,1
	ld	R16,Z
	rcall	PrintChar
	ld	R16,-Z
	rcall	PrintChar
	adiw	R30,2
	dec	R17
	brne	PrintStrRAMrev
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	odesle pres USART retezec znaku od ukazatele Z z FLASH
;-----------------------------------------------------------------------------------------------------------------------
PrintStrFLASH:	ldi	R16,0b00001000	;timer 0 - stop
	out	tccr0,R16
	;
PrintStrFLASH1:	sbis	ucsra,udre
	rjmp	PrintStrFLASH1	;cekat na vyprazdneni zasobniku
	lpm	R16,Z+
	cpi	R16,0x00	;kdyz je to 0x00, tak nepsat nic - to je zalomeni radku pro LCD
	brne	PrintStrFLASH2
	ldi	R16,' '
PrintStrFLASH2:	out	udr,R16
	lpm	R16,Z
	cpi	R16,0xFF
	brne	PrintStrFLASH1
	;
	ldi	R16,0b00001011	;timer 0 - delitel XTAL/64
	out	tccr0,R16		
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	odesle pres USART znak z R16
;-----------------------------------------------------------------------------------------------------------------------
PrintChar:	ldi	R18,0b00001000	;timer 0 - stop
	out	tccr0,R18
	;
PrintChar1:	sbis	ucsra,udre
	rjmp	PrintChar1	;cekat na vyprazdneni zasobniku
	out	udr,R16
	;
	ldi	R18,0b00001011	;timer 0 - delitel XTAL/64
	out	tccr0,R18		
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	zalomit radek pres USART
;-----------------------------------------------------------------------------------------------------------------------
TermBreakLine:	ldi	R16,0xA
	rcall	PrintChar
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vypise 2*SubFoldLev mezer pres USART
;-----------------------------------------------------------------------------------------------------------------------
PrintSFtab:	lds	R17,SubFolderLev
	cpi	R17,0
	breq	PrintSFtabOk
	lsl	R17
	ldi	R16,' '
PrintSFtabl1:	rcall	PrintChar
	dec	R17
	brne	PrintSFtabl1
PrintSFtabOk:	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vypis BCD cisla s potlacenim nul na zacatku pro 16/24/32bit cisla
;-----------------------------------------------------------------------------------------------------------------------
USRwrBCD32:	ldi	R17,32	;32 bitu v R11:R12:R13:R14:R15
	rjmp	USRwrBCDcom
USRwrBCD24:	ldi	R17,24	;24 bitu v R12:R13:R14:R15
	rjmp	USRwrBCDcom
USRwrBCD16:	ldi	R17,16	;16 bitu v R13:R14:R15
	;
USRwrBCDcom:	clt
	mov	R16,R15
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	cpi	R16,48
	breq	NextNMBR0
	set
	rcall	PrintChar
NextNMBR0:	mov	R16,R15
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR1
	cpi	R16,48
	breq	NextNMBR1
	set
NMBR1:	rcall	PrintChar
NextNMBR1:	mov	R16,R14
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR2
	cpi	R16,48
	breq	NextNMBR2
	set
NMBR2:	rcall	PrintChar
NextNMBR2:	mov	R16,R14
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR3
	cpi	R16,48
	breq	NextNMBR3
	set
NMBR3:	rcall	PrintChar
NextNMBR3:	mov	R16,R13
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR4
	cpi	R16,48
	breq	NextNMBR4
	set
NMBR4:	rcall	PrintChar
NextNMBR4:	mov	R16,R13
	andi	R16,0b00001111
	cpi	R17,24
	brcc	USRwrUSR24p	;pro > 24 bitu
	subi	R16,-48
	rcall	PrintChar
	ret
	;jen pro 24 bitu
USRwrUSR24p:	subi	R16,-48
	brts	NMBR5
	cpi	R16,48
	breq	NextNMBR5
	set
NMBR5:	rcall	PrintChar
NextNMBR5:	mov	R16,R12
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR6
	cpi	R16,48
	breq	NextNMBR6
	set
NMBR6:	rcall	PrintChar
NextNMBR6:	mov	R16,R12
	andi	R16,0b00001111
	cpi	R17,32
	breq	USRwrUSR32p	;pro > 32 bitu
	subi	R16,-48
	rcall	PrintChar
	ret
	;jen pro 32 bitu
USRwrUSR32p:	subi	R16,-48
	brts	NMBR7
	cpi	R16,48
	breq	NextNMBR7
	set
NMBR7:	rcall	PrintChar
NextNMBR7:	mov	R16,R11
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR8
	cpi	R16,48
	breq	NextNMBR8
	set
NMBR8:	rcall	PrintChar
NextNMBR8:	mov	R16,R11
	andi	R16,0b00001111
	subi	R16,-48
	rcall	PrintChar
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vytvoreni LFN nazvu a vypis
;-----------------------------------------------------------------------------------------------------------------------
PrintFFname:	push	R30
	push	R31	;zaloha Z
	rcall	PrintSFtab	;odsazeni textu zleva podle urovne podadresare
	ld	R16,Z	;nacist atribut
	bst	R16,4	;priznak adresare
	ldi	R30,low(TextFileT*2)
	ldi	R31,high(TextFileT*2)	;kdyz je to soubor
	brtc	PrintFFnameFd
	ldi	R30,low(TextFoldT*2)
	ldi	R31,high(TextFoldT*2)	;kdyz je to adresar
PrintFFnameFd:	rcall	PrintStrFLASH	;napis text podle pro A nebo S
	rcall	ReadLongName	;ted vytvorit LFN nebo SFN nazev
	ldi	R30,low(EntryNameString)
	ldi	R31,high(EntryNameString)	;tady zacina retezec nazvu
	lds	R17,EntryNameLen	;delka retezce nazvu
	rcall	PrintStrRAM	;a vypsat na USART
	;zalomit radek
;	ldi	R16,0xD
;	rcall	PrintChar
	ldi	R16,0xA
	rcall	PrintChar
	;inkrementovat pocitadlo vypsanych polozek
	lds	R16,TotalEntries+0
	lds	R17,TotalEntries+1
	subi	R16,low(-1)
	sbci	R17,high(-1)
	sts	TotalEntries+0,R16
	sts	TotalEntries+1,R17
	;job complete
	pop	R31
	pop	R30
	;jeste pricist delku souboru do celkove delky
	ld	R16,Z
	bst	R16,4	;pro adreasre nic nepricitat
	brts	NotCanIncTFS
	;
	adiw	R30,0x11
	lds	R16,TreeFilesSize+0
	lds	R17,TreeFilesSize+1
	lds	R18,TreeFilesSize+2
	lds	R19,TreeFilesSize+3
	ld	R20,Z+
	ld	R21,Z+
	ld	R22,Z+
	ld	R23,Z+
	add	R16,R20
	adc	R17,R21
	adc	R18,R22
	adc	R19,R23
	sts	TreeFilesSize+0,R16
	sts	TreeFilesSize+1,R17
	sts	TreeFilesSize+2,R18
	sts	TreeFilesSize+3,R19
	sbiw	R30,0x15
	;
NotCanIncTFS:	ret
;-----------------------------------------------------------------------------------------------------------------------
;	vypis titulku na terminal a podtrzeni carou "------"
;-----------------------------------------------------------------------------------------------------------------------
PrintHDLN:	rcall	PrintStrFLASH	;napsat titulek
	rcall	TermBreakLine	;zalomit lajnu
	ldi	R17,60
	ldi	R16,'-'
PrintHDLN1:	rcall	PrintChar
	dec	R17
	brne	PrintHDLN1	;60x napsat '-'
	rcall	TermBreakLine	;zalomit lajnu
	ret
;***********************************************************************************************************************
;	Tady jsou vsechny rutiny pro LCD
;***********************************************************************************************************************
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	vymaze cele LCD
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDclrAll:	sbi	portb,1
	ldi	R25,128
LCDclrAll1:	ldi	R16,' '
	rcall	ByteToLCD
	dec	R25
	brne	LCDclrAll1
	ldi	R16,0b10000000
	rcall	LCDsetPos
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	nastavi pozici na LCD podle R16
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDsetPos:	cbi	portb,1
	rcall	ByteToLCD
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	posle znak z R16 na LCD
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDwrChar:	sbi	portb,1
	rcall	ByteToLCD
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;vypise retezec z od adresy udane Z, retezec se ukoncuje 0xFF, radek zalamuje 0x00
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDwrStrFlash:	sbi	portb,1
LCDwrStrFlash1:	lpm	R16,Z+
	rcall	ByteToLCD
	lpm	R16,Z
	cpi	R16,0
	brne	LCDNeBrLine
	ldi	R16,0b11000000
	rcall	LCDsetPos
	sbi	portb,1
	adiw	R30,1
LCDNeBrLine:	lpm	R16,Z
	cpi	R16,255
	brne	LCDwrStrFlash1
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	odesle R25 znaku z RAM od ukazatele Z
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDwrStrRAM:	sbi	portb,1	;data
LCDwrStrRAM1:	ld	R16,Z+
	rcall	ByteToLCD
	dec	R25
	brne	LCDwrStrRAM1
	ret
;--------------------------------------------------------------------------------------------------------------------------------------------------- 	
;	inicializace LCD jako 2 radkovy
;---------------------------------------------------------------------------------------------------------------------------------------------------
LCDinit:	rcall	ByteToLCDst
	ldi	R16,0b00111000
	rcall	ByteToLCD
	ldi	R16,0b00001100
	rcall	ByteToLCD
	ldi	R16,0b10000000
	rcall	ByteToLCD
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	posle byte LCD a generuje zpozdeni neco pres 40us	
;---------------------------------------------------------------------------------------------------------------------------------------------------
ByteToLCD:	out	portc,R16
	sbi	portb,0
	nop
	cbi	portb,0
	ldi	R16,250
ByteToLCDL1:	dec	R16
	nop
	brne	ByteToLCDL1
	ret
;---------------------------------------------------------------------------------------------------------------------------------------------------
;	jen zpozdeni po zapnuti (nektere LCD se nechtely inicializovat)
;---------------------------------------------------------------------------------------------------------------------------------------------------
ByteToLCDst:	ldi	R17,5
	ldi	R16,0	
ByteToLCDst1:	dec	R16
	brne	ByteToLCDst1
	dec	R17
	brne	ByteToLCDst1
	ret	
;***********************************************************************************************************************
;	tady zacina matematika
;***********************************************************************************************************************
	;nasobeni 16x16 unsigned
mul16u:	clr	R2
	mul	R23,R21
	movw	R18,R0
	mul	R22,R20
	movw	R16,R0
	mul	R23,R20
	add	R17,R0
	adc	R18,R1
	adc	R19,R2
	mul	R21,R22
	add	R17,R0
	adc	R18,R1
	adc	R19,R2
	ret
;------------------------------------------------------------------------------------------------------------------------
; div32uc2 - 32/32 bit unsigned division, code size optimized 
; deleni dvou neznaminkovych 32-bit cisel, optimalizovano na delku kodu, o neco rychlejsi nez predchozi
;
; dDd32r0u:dDd32r1u:dDd32r2u:dDd32r3u <- dDd32r0u:dDd32r1u:dDd32r2u:dDd32r3u div dDs32r0u:dDs32r1u:dDs32r2u:dDs32r3u
; dRe32r0u:dRe32r1u:dRe32r2u:dRe32r3u <- dDd32r0u:dDd32r1u:dDd32r2u:dDd32r3u mod dDs32r0u:dDs32r1u:dDs32r2u:dDs32r3u
;
; words:  29 + ret
; cycles: 528/608/688 + ret [min/avg/max]
;------------------------------------------------------------------------------------------------------------------------
	.def	dRe32r0u=R12
	.def	dRe32r1u=R13
	.def	dRe32r2u=R14
	.def	dRe32r3u=R15
	.def	dDd32r0u=R16
	.def	dDd32r1u=R17
	.def	dDd32r2u=R18
	.def	dDd32r3u=R19
	.def	dDs32r0u=R20
	.def	dDs32r1u=R21
	.def	dDs32r2u=R22
	.def	dDs32r3u=R23
	.def	d32cntu=R24
	;
div32uc2:	clr	dRe32r0u
	clr	dRe32r1u
	clr	dRe32r2u
	sub	dRe32r3u,dRe32r3u
	ldi	d32cntu,33
d32u_1c2:	rol	dDd32r0u
	rol	dDd32r1u
	rol	dDd32r2u
	rol	dDd32r3u
	dec	d32cntu
	breq	d32u_2c2
	rol	dRe32r0u
	rol	dRe32r1u
	rol	dRe32r2u
	rol	dRe32r3u
	sub	dRe32r0u,dDs32r0u
	sbc	dRe32r1u,dDs32r1u
	sbc	dRe32r2u,dDs32r2u
	sbc	dRe32r3u,dDs32r3u
	brcc	d32u_1c2
	add	dRe32r0u,dDs32r0u
	adc	dRe32r1u,dDs32r1u
	adc	dRe32r2u,dDs32r2u
	adc	dRe32r3u,dDs32r3u
	rjmp	d32u_1c2
d32u_2c2:	com	dDd32r0u
	com	dDd32r1u
	com	dDd32r2u
	com	dDd32r3u
	ret
;------------------------------------------------------------------------------------------
; div16uc2 - 16/16 bit unsigned division, code size optimized
; deleni dvou neznaminkovych 16-bit cisel, optimalizovano na delku kodu, o neco rychlejsi nez predchozi
;
; dDd16r0u:dDd16r1u <- dDd16r0u:dDd16r1u div dDs16r0u:dDs16r1u
; dRe16r0u:dRe16r1u <- dDd16r0u:dDd16r1u mod dDs16r0u:dDs16r1u
;
; words:  17 + ret                         (puvodni od ATMELu: 18 + ret)
; cycles: 170/194/218 + ret [min/avg/max]  (puvodni od ATMELu: 231/239/247 + ret)
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------
	.def	dRe16r0u=R14
	.def	dRe16r1u=R15
	.def	dDd16r0u=R16
	.def	dDd16r1u=R17
	.def	dDs16r0u=R18
	.def	dDs16r1u=R19
	.def	d16cntu=R20
	;
div16uc2:	clr	dRe16r0u
	sub	dRe16r1u,dRe16r1u
	ldi	d16cntu,17
d16u_1c2:	rol	dDd16r0u
	rol	dDd16r1u
	dec	d16cntu
	breq	d16u_2c2
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_1c2
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
	rjmp	d16u_1c2
d16u_2c2:	com	dDd16r0u
	com	dDd16r1u
	ret
;------------------------------------------------------------------------------------------------------------------------
; bin2BCD16p5 - 16-bit binary to 5-digit packed BCD conversion (0..65535)
; prevod 16-bit binarniho cisla na peticiferne cislo v BCD
;
; BCD16res0:BCD16res1:BCD16res2 <- bin16r0:bin16r1
;
; words:  29 + ret
; cycles: 29/185 + ret [min/max]
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------------------------------------
	.def	BCD16res0=R13
	.def	BCD16res1=R14
	.def	BCD16res2=R15
	.def	bin16r0=R16
	.def	bin16r1=R17
	.def	BB16_cnt1=R30
	.def	BB16_cnt2=R31

bin2BCD16p5:	ser	BB16_cnt2
	mov	BCD16res2,BB16_cnt2
BB16p5_L10k:	inc	BCD16res2
	subi	bin16r0,low(10000)
	sbci	bin16r1,high(10000)
	brcc	BB16p5_L10k
	subi	bin16r0,low(-10000)
	sbci	bin16r1,high(-10000)
	ldi	BB16_cnt1,(256-16)
BB16p5_L1k:	subi	BB16_cnt1,(-16)
	subi	bin16r0,low(1000)
	sbci	bin16r1,high(1000)
	brcc	BB16p5_L1k
	subi	bin16r0,low(-1000)
	sbci	bin16r1,high(-1000)
	mov	BCD16res1,BB16_cnt2
BB16p5_L100:	inc	BCD16res1
	subi	bin16r0,low(100)
	sbci	bin16r1,high(100)
	brcc	BB16p5_L100
	subi	bin16r0,low(-100)
	or	BCD16res1,BB16_cnt1
	ldi	BB16_cnt1,(256-16)
BB16p5_L10:	subi	BB16_cnt1,(-16)
	subi	bin16r0,10
	brcc	BB16p5_L10
	subi	bin16r0,-10
	mov	BCD16res0,BB16_cnt1
	or	BCD16res0,bin16r0
	ret
;------------------------------------------------------------------------------------------------------------------------
; bin2BCD24p8 - 24-bit binary to 8-digit packed BCD conversion (0..16777215)
; prevod 24-bit binarniho cisla na peticiferne cislo v BCD
;
; BCD24res0:BCD24res1:BCD24res2:BCD24res3 <- bin24r0:bin24r1:bin24r2
;
; words:  59 + ret
; cycles: 29/401  + ret [min/max]
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------------------------------------
	.def	BCD24res0=R12
	.def	BCD24res1=R13
	.def	BCD24res2=R14
	.def	BCD24res3=R15
	.def	bin24r0=R16
	.def	bin24r1=R17
	.def	bin24r2=R18
	.def	BB24_cnt1=R30
	.def	BB24_cnt2=R31

bin2BCD24p8:	ser	BB24_cnt2
	ldi	BB24_cnt1,(256-16)
BB24p8_L10M:	subi	BB24_cnt1,(-16)
	subi	bin24r0,0x80
	sbci	bin24r1,0x96
	sbci	bin24r2,0x98	; +10000000
	brcc	BB24p8_L10M
	subi	bin24r0,0x80
	sbci	bin24r1,0x69
	sbci	bin24r2,0x67	; -10000000
	mov	BCD24res3,BB24_cnt2
BB24p8_L1M:	inc	BCD24res3
	subi	bin24r0,0x40
	sbci	bin24r1,0x42
	sbci	bin24r2,0x0F	; +1000000
	brcc	BB24p8_L1M
	subi	bin24r0,0xC0
	sbci	bin24r1,0xBD
	sbci	bin24r2,0xF0	; -1000000
	or	BCD24res3,BB24_cnt1
	ldi	BB24_cnt1,(256-16)
BB24p8_L100k:	subi	BB24_cnt1,(-16)
	subi	bin24r0,0xA0
	sbci	bin24r1,0x86
	sbci	bin24r2,0x01	; +100000
	brcc	BB24p8_L100k
	subi	bin24r0,0x60
	sbci	bin24r1,0x79
	sbci	bin24r2,0xFE	; -100000
	mov	BCD24res2,BB24_cnt2
BB24p8_L10k:	inc	BCD24res2
	subi	bin24r0,0x10
	sbci	bin24r1,0x27
	sbci	bin24r2,0x00	; +10000
	brcc	BB24p8_L10k
	subi	bin24r0,0xF0
	sbci	bin24r1,0xD8	; -10000
	or	BCD24res2,BB24_cnt1
	ldi	BB24_cnt1,(256-16)
BB24p8_L1k:	subi	BB24_cnt1,(-16)
	subi	bin24r0,low(1000)
	sbci	bin24r1,high(1000)	; +1000
	brcc	BB24p8_L1k
	subi	bin24r0,low(-1000)
	sbci	bin24r1,high(-1000)	; -1000
	mov	BCD24res1,BB24_cnt2
BB24p8_L100:	inc	BCD24res1
	subi	bin24r0,low(100)
	sbci	bin24r1,high(100)	; +100
	brcc	BB24p8_L100
	subi	bin24r0,low(-100)	; -100
	or	BCD24res1,BB24_cnt1
	ldi	BB24_cnt1,(256-16)
BB24p8_L10:	subi	BB24_cnt1,(-16)
	subi	bin24r0,10	; +10
	brcc	BB24p8_L10
	subi	bin24r0,-10	; -10
	mov	BCD24res0,bin24r0
	or	BCD24res0,BB24_cnt1
	ret
;------------------------------------------------------------------------------------------------------------------------
; bin2BCD32p10 - 32-bit binary to 10-digit packed BCD conversion (0..4294967295)
; prevod 32-bit binarniho cisla na peticiferne cislo v BCD
;
; BCD32res0:BCD32res1:BCD32res2:BCD32res3:BCD32res4 <- bin32r0:bin32r1:bin32r2:bin32r3
;
; words:  83 + ret
; cycles: 83/525 + ret [min/max]
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------------------------------------
	.def	BCD32res0=R11
	.def	BCD32res1=R12
	.def	BCD32res2=R13
	.def	BCD32res3=R14
	.def	BCD32res4=R15
	.def	bin32r0=R16
	.def	bin32r1=R17
	.def	bin32r2=R18
	.def	bin32r3=R19
	.def	BB32_cnt1=R30
	.def	BB32_cnt2=R31
	
bin2BCD32p10:	ser	BB32_cnt2
	ldi	BB32_cnt1,(256-16)
BB32p10_L1G:	subi	BB32_cnt1,(-16)
	subi	bin32r0,0x00
	sbci	bin32r1,0xCA
	sbci	bin32r2,0x9A
	sbci	bin32r3,0x3B	; +1000000000
	brcc	BB32p10_L1G
	subi	bin32r0,0x00
	sbci	bin32r1,0x36
	sbci	bin32r2,0x65
	sbci	bin32r3,0xC4	; -1000000000
	mov	BCD32res4,BB32_cnt2
BB32p10_L100M:	inc	BCD32res4
	subi	bin32r0,0x00
	sbci	bin32r1,0xE1
	sbci	bin32r2,0xF5
	sbci	bin32r3,0x05	; +100000000
	brcc	BB32p10_L100M
	subi	bin32r0,0x00
	sbci	bin32r1,0x1F
	sbci	bin32r2,0x0A
	sbci	bin32r3,0xFA	; -100000000
	or	BCD32res4,BB32_cnt1
	ldi	BB32_cnt1,(256-16)
BB32p10_L10M:	subi	BB32_cnt1,(-16)
	subi	bin32r0,0x80
	sbci	bin32r1,0x96
	sbci	bin32r2,0x98
	sbci	bin32r3,0x00	; +10000000
	brcc	BB32p10_L10M
	subi	bin32r0,0x80
	sbci	bin32r1,0x69
	sbci	bin32r2,0x67	; -10000000
	mov	BCD32res3,BB32_cnt2
BB32p10_L1M:	inc	BCD32res3
	subi	bin32r0,0x40
	sbci	bin32r1,0x42
	sbci	bin32r2,0x0F	; +1000000
	brcc	BB32p10_L1M
	subi	bin32r0,0xC0
	sbci	bin32r1,0xBD
	sbci	bin32r2,0xF0	; -1000000
	or	BCD32res3,BB32_cnt1
	ldi	BB32_cnt1,(256-16)
BB32p10_L100k:	subi	BB32_cnt1,(-16)
	subi	bin32r0,0xA0
	sbci	bin32r1,0x86
	sbci	bin32r2,0x01	; +100000
	brcc	BB32p10_L100k
	subi	bin32r0,0x60
	sbci	bin32r1,0x79
	sbci	bin32r2,0xFE	; -100000
	mov	BCD32res2,BB32_cnt2
BB32p10_L10k:	inc	BCD32res2
	subi	bin32r0,0x10
	sbci	bin32r1,0x27
	sbci	bin32r2,0x00	; +10000
	brcc	BB32p10_L10k
	subi	bin32r0,0xF0
	sbci	bin32r1,0xD8	; -10000
	or	BCD32res2,BB32_cnt1
	ldi	BB32_cnt1,(256-16)
BB32p10_L1k:	subi	BB32_cnt1,(-16)
	subi	bin32r0,low(1000)
	sbci	bin32r1,high(1000)	; +1000
	brcc	BB32p10_L1k
	subi	bin32r0,low(-1000)
	sbci	bin32r1,high(-1000)	; -1000
	mov	BCD32res1,BB32_cnt2
BB32p10_L100:	inc	BCD32res1
	subi	bin32r0,low(100)
	sbci	bin32r1,high(100)	; +100
	brcc	BB32p10_L100
	subi	bin32r0,low(-100)	; -100
	or	BCD32res1,BB32_cnt1
	ldi	BB32_cnt1,(256-16)
BB32p10_L10:	subi	BB32_cnt1,(-16)
	subi	bin32r0,10	; +10
	brcc	BB32p10_L10
	subi	bin32r0,-10	; -10
	mov	BCD32res0,bin32r0
	or	BCD32res0,BB32_cnt1
	ret
;***********************************************************************************************************************
;	Rutiny zpozdeni
;***********************************************************************************************************************
;-----------------------------------------------------------------------------------------------------------------------
;	nastavitelne zpozdeni (R16)
;-----------------------------------------------------------------------------------------------------------------------
DelayLongVar:	clr	R0
	clr	R1
DelLvar:	dec	R1
	brne	DelLvar
	dec	R0
	brne	DelLvar
	dec	R16
	brne	DelLvar
	ret
;-----------------------------------------------------------------------------------------------------------------------
;	nastavitelne kratke zpozdeni (R16)
;-----------------------------------------------------------------------------------------------------------------------
DelayShortVar:	clr	R0
DelSvar:	dec	R0
	brne	DelSvar
	dec	R16
	brne	DelSvar
	ret
	
	
TextHDDinitT:	.db	"Inicializace HDD/CF",0xFF
TextWaitBSYT:	.db	"Cekam na BUSY",0xFF
TextWaitDRYT:	.db	"Cekam na drive RDY",0xFF
TextIDEidentRDT:	.db	"Nacitam identifikaci",0x00,"z HDD/CF",0xFF
TextFATldT:	.db	"Nacitam FAT do SRAM",0xFF
TextTreeWRT:	.db	"Probiha vypis stromu",0xFF
TextTreeWRcompT:	.db	"Vypis dokoncen",0xFF
TextIDEparT:	.db	"Nektere parametry IDE zarizeni",0xFF	
TextMNT:	.db	"Model number: ",0xFF
TextSNT:	.db	"Serial number: ",0xFF
TextFWT:	.db	"Controller firmware revision: ",0xFF
TextTEntrT:	.db	"Vypsanych polozek: ",0xFF
TextCylsT:	.db	"Cylindry: ",0xFF
TextSPTT:	.db	"Sektory na stopu: ",0xFF
TextHeadsT:	.db	"Hlavy: ",0xFF
TextCHSkapT:	.db	"CHS kapacita v sektorech: ",0xFF
TextLBAkapT:	.db	"LBA kapacita v sektorech: ",0xFF
TextLBAkapMBT:	.db	"LBA kapacita: ",0xFF
TextMBT:	.db	"MB",0xFF
TextkBT:	.db	"kB",0xFF
TextBT:	.db	"B",0xFF
TextFATparT:	.db	"Nektere parametry FAT16",0xFF
TextDLT:	.db	"Disk label: ",0xFF
TextOEMT:	.db	"Operacni system (OEM): ",0xFF
TextCST:	.db	"Velikost clusteru: ",0xFF
TextCCT:	.db	"Pocet clusteru: ",0xFF
TextFATCT:	.db	"Pocet FAT: ",0xFF
TextFATlenT:	.db	"Pocet sektoru v 1 FAT: ",0xFF
TextPSizT:	.db	"Velikost 1 partition: ",0xFF
TextRootEntrT:	.db	"Pocet vstupu do root: ",0xFF
TextCS512T:	.db	"512B",0xFF
TextTreePrintT:	.db	"Vypis stromu",0xFF
TextTreeCPTDT:	.db	"Nektere informace o vypisu stromu",0xFF
TextTreeTimeT:	.db	"Doba vypisu: ",0xFF
TextTreeFsizT:	.db	"Celkova velikost souboru: ",0xFF
TextMSecT:	.db	"ms",0xFF
TextSecT:	.db	"sec ",0xFF
TextMinT:	.db	"min ",0xFF
TextF16brnT:	.db	"FAT16 boot record",0x00,"nebyl nalezen",0xFF
TextNF16T:	.db	"1.part. neni FAT16",0xFF
TextNF16fT:	.db	"nalezeno: ",0xFF
TextMBRnfT:	.db	"MBR nebyl nalezen",0xFF
TextFileT:	.db	"S:",0xFF
TextFoldT:	.db	"A:",0xFF